#ifndef _QHVC_INTERACT_H_
#define _QHVC_INTERACT_H_

#pragma once

#include "QHVCSdk.h"
#include "QHVCInteractCallback.h"
#include "QHVCInteractConstant.h"

namespace QHVC
{
    namespace INTERACT
    {
        namespace QHVCInteract {

            /**
            * ȡSDK汾
            *
            * @return SDK汾
            */
            QHVC_API const char* GetVersion();

#pragma region 

            /**
            * ùҵϢ÷Ҫʵ֮ǰãҵҪһЩҪϢҵ֡ͳʹá
            *
            * @param channelId Idֹ˾ӵжӦáֱΪӦó򿪷ǩûУֱ롣
            * @param appKey ֱΪӦó򿪷ǩApp KeyûУֱ롣
            * @param userSign  ûǩֱṩ㷨ɴ User Signڷû֤
            */
            QHVC_API void SetPublicServiceInfo(const char* channelId, const char*  appKey, const char*  userSign);

            /**
            * ػֱݣ׼ø÷ǰȵsetPublicServiceInfoҵϢ׼
            * ڸ÷úܵʵ÷첽ִУصִִ֮ʵ
            *
            * @param roomId           Id
            * @param userId           ûid
            * @param sessionId        ỰIDڱʶҵỰÿһ֮󣬸ֵҪ
            * @param optionInfo       ѡֵ䣬ʹjson·ֱܵȿֵͨãҵ׼ʹƵƵֱ
            *                         ͨapplyforBypassLiveAddressӿ 
            *                         : {"push_addr":"xxx", "pull_addr";"xxxx"},μ
            *                         {@link QHVC#INTERACT#ENGINE_OPTION}塣
            * @param interactCallBack ص
            * @return 0:ʾɹ,ʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int LoadEngine(const char*  roomId, const char*  userId, const char*  sessionId, const char* optionInfo,
                const IQHVCInteractCallback* interactCallBack);

            /**
            * ͷ
            */
            QHVC_API void ReleaseEngine();


            /**
            * ÷ûͨƵͬһƵڵûԻͨûͬһƵ
            * ȺġͨУûleaveChannel ˳ǰͨܽһƵ
            *
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int JoinChannel();


            /**
            * 뿪Ƶ
            * Ҷϻ˳ͨjoinChannel󣬱leaveChannelԽͨܽһͨܵǰ
            * ǷͨУԵleaveChannelûиáleaveChannelѻỰصԴͷŵleaveChannel
            * 첽÷ʱû˳Ƶ˳ƵSDKᴥIQHVCInteractCallBack.onLeaveChannel()
            *
            * @return 0 ɹ, ʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int LeaveChannel();

            /**
            * ÷Ƶģʽ(Profile) SDK֪Ӧóʹó Ӷʹ
            * ͬŻֶΡ
            * ע
            *     1. ͬһƵֻͬʱһģʽ
            *     2. ÷ڽƵǰãƵЧ
            *
            * @param profile ָƵͨģʽ(profile)֧ģʽ
            *                QHVC#INTERACT#CHANNEL_PROFILE_COMMUNICATION (ͨģʽĬ)
            *                QHVC#INTERACT#CHANNEL_PROFILE _LIVE_BROADCASTING (ֱģʽ)
            *                QHVC#INTERACT#CHANNEL_PROFILE_GAME (Ϸģʽ)
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetChannelProfile(CHANNEL_PROFILE profile);

            /**
            * Ƶģʽ, ÷ڿƵģʽڼƵǰͨеãڼƵǰãԶ
            * ƵģʽͨеƵģʽлΪƵģʽ disablevideo ɹر
            * Ƶģʽ
            *
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int EnableVideo();

            /**
            * Ƶģʽ, ÷ڹرƵƵģʽڼƵǰͨеãڼƵǰ
            * ãԶƵģʽͨеƵģʽлΪƵƵģʽ
            * enablevideo ɿƵģʽ
            *
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int DisableVideo();

            /**
            * /ñƵܡ÷ֻƵ÷Ҫͷ
            *
            * @param enabled true: ñƵĬϣ false: ñƵ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int EnableLocalVideo(bool enabled);

            /**
            * ÷ûƵŻѡ
            *
            * @param preferFrameRateOverImageQuality true: ʺȱ֤(Ĭ),false: ʺȱ֤
            * @return 0 ɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetVideoQualityParameters(bool preferFrameRateOverImageQuality);

            /**
            * ÷ƵԤڿԤǰȵ setupLocalVideo Ԥڼ
            * ԣұ enableVideo Ƶܡڵ joinChannel Ƶ֮ǰ
            * startPreview ƵԤڵ leaveChannel ˳Ƶ֮󱾵ԤȻ
            * ״̬ҪرձԤҪ stopPreview
            * עʹSDKɼƵҵԲɼƵʱ벻Ҫá
            *
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int StartPreview();

            /**
            * ÷ֹͣƵԤ
            *
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int StopPreview();

            /**
            * ģʽ
            * ÷ģʽ(ĬΪ״̬)
            *
            * @return 0 ɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int EnableAudio();

            /**
            * رģʽ
            *
            * @return 0 ɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int DisableAudio();

            /**
            * һЩSDK
            *
            * @param options jsonʽ
            * @return 0 ɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetParameters(const char* options);

            /**
            * úлûģʽ
            * ڼƵǰûҪͨùڻģʽĬϣ
            * ڼƵûͨлûģʽ
            * ÷ֱģʽЧ
            *
            * @param role ֱûɫ QHVC#INTERACT#CLIENT_ROLE_BROADCASTER :
            *             QHVC#INTERACT#CLIENT_ROLE_GUEST α
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetClientRole(CLIENT_ROLE role);

            /**
            * ɫ
            *
            * @param role ɫƣҪƵһ£б
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetCloudControlRole(const char* role);

            /**
            * ÷ñƵʾϢӦóͨô˽ӿڰ󶨱ƵʾӴ(view)
            * ƵʾģʽӦó򿪷У ͨڳʼø÷бƵã
            * ȻټƵ˳Ƶ󣬰ȻЧҪ󶨣ָ(NULL)View
            *  setupLocalVideo
            *
            * @param view       ƵʾӴ
            * @param renderMode Ƶʾģʽ
            *                   QHVC#INTERACT#RENDER_MODE_HIDDEN (1): ƵߴʾӴߴ粻һ£ƵᰴʾӴıܱ߲üͼӴ
            *                   QHVC#INTERACT#ENDER_MODE_FIT(2): ƵߴʾӴߴ粻һ£ڱֳȵǰ£ƵźӴ
            *                   QHVC#INTERACT#RENDER_MODE_ADAPTIVE(3)ԼͶԷԼͶԷǺʹRENDER_MODE_HIDDENԷԼһ
            *                   һʹ RENDER_MODE_FIT
            * @param uid        ûID,  joinchannel е uid һ¡
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetupLocalVideo(HWND view, RENDER_MODE renderMode, const char* uid);

            /**
            * ÷Զûʾͼ趨 uid ָûĸͼʾһ·ҵʲôʱʾĳûİͼԵremoveRemoteVideo
            * ˳Ƶ SDK Զûİ󶨹ϵ
            *
            * @param view       ƵʾӴ
            * @param renderMode Ƶʾģʽ
            *                   QHVC#INTERACT#RENDER_MODE_HIDDEN (1): ƵߴʾӴߴ粻һ£ƵᰴʾӴıܱ߲üͼӴ
            *                   QHVC#INTERACT#RENDER_MODE_FIT(2): ƵߴʾӴߴ粻һ£ڱֳȵǰ£ƵźӴ
            *                   QHVC#INTERACT#RENDER_MODE_ADAPTIVE(3)ԼͶԷԼͶԷǺʹ RENDER_MODE_HIDDENԷԼһһʹRENDER_MODE_FIT
            * @param uid        û IDָԶƵĸû
            * @param streamId   IDָԶƵID
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetupRemoteVideo(HWND view, RENDER_MODE renderMode, const char* uid, const char* streamId);

            /**
            * ÷ڽԶûʾͼԶû뿪Ƶ󣬵ô˷
            *
            * @param streamId ָԶƵID
            * @param uid      ûIDָԶƵĸû
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int RemoveRemoteVideo(const char* streamId, const char* uid);

            /**
            * ÷ñƵʾģʽӦóԶεô˷ʾģʽ
            * עʹSDKɼƵҵԲɼƵʱ벻Ҫá
            *
            * @param mode Ƶʾģʽ
            *             QHVC#INTERACT#RENDER_MODE_HIDDEN (1): ƵߴʾӴߴ粻һ£ƵᰴʾӴıܱ߲üͼӴ
            *             QHVC#INTERACT#RENDER_MODE_FIT(2): ƵߴʾӴߴ粻һ£ڱֳȵǰ£ƵźӴ
            *             QHVC#INTERACT#RENDER_MODE_ADAPTIVE(3)ԼͶԷԼͶԷǺʹRENDER_MODE_HIDDENԷԼһһʹ RENDER_MODE_FIT
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetLocalRenderMode(RENDER_MODE mode);

            /**
            * ÷ԶƵʾģʽӦóԶεô˷ʾģʽ
            *
            * @param uid  û ID
            * @param mode Ƶʾģʽ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetRemoteRenderMode(const char*  uid, RENDER_MODE mode);

            /**
            * ÷Ƶ(Profile)ÿԶӦһƵֱʡ֡ʡʵȡ豸ͷ
            * ָ֧ķֱʱ SDK ԶѡһʵͷֱʣǱֱȻ setVideoProfile ָġ
            * ע1. Ӧڵ joinChannel/startPreview ǰƵԡ
            * 2. ÷ñԣܸʾԲһ£ֱΪ 640x480
            * תΪ 90 ȣʾķֱΪģʽ
            *
            * @param profile            Ƶ(Profile)QHVCInteractConstant.VideoProfileеĶ塣
            * @param swapWidthAndHeight Ƿ񽻻͸ߡ    true͸  false͸(Ĭ)
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetVideoProfile(VIDEO_PROFILE profile, bool swapWidthAndHeight);

            /**
            * ÷Ƶ
            *
            * @param width Ƶֱ-
            * @param height Ƶֱ-
            * @param frameRate Ƶ֡
            * @param bitrate Ƶ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetVideoProfileEx(int width, int height, int frameRate, int bitrate);

            /**
            * ͣ/ָͱƵ÷/ֹ緢ͱƵ
            * ע ÷Ӱ챾Ƶȡûнͷ
            *
            * @param muted True: ͱƵ  False: ͱƵ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int MuteLocalVideoStream(bool muted);

            /**
            * ͣ/ָƵ/ֹ˵Ƶ
            * ע ÷ӰƵĽգֻǲƵ
            *
            * @param muted True: ֹͣŽյƵ False: ŽյƵ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int MuteAllRemoteVideoStreams(bool muted);

            /**
            * ͣ/ָָԶƵ/ָֹԶƵ
            * ע ÷ӰƵĽգֻǲƵ
            *
            * @param uid   ָû
            * @param muted True: ֹͣŽյƵ False: ŽյƵ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int MuteRemoteVideoStream(const char* uid, bool muted);

            /**
            * ˵ʾ÷ SDK Ӧóǰ˭˵Լ˵ߵ
            *
            * @param interval ָʾʱ
            *                 <= 0ʾ
            *                 > 0ʾļλΪ롣õ 200 롣
            *                 ø÷ƵǷ˵˵ʾص (onAudioVolumeIndication) صаõļʱ䷵ʾ
            * @param smooth ƽϵĬϿΪ3
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int EnableAudioVolumeIndication(int interval, int smooth);

            /**
            * /ȡ÷/ֹ緢ͱƵ
            * ע ÷Ӱ¼״̬ûн˷硣
            *
            * @param muted True˷羲  Falseȡ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int MuteLocalAudioStream(bool muted);

            /**
            * Զû/Զûȡ/ֹԶûƵ
            * ע ÷ӰƵĽգֻǲƵ
            *
            * @param muted True˷羲  Falseȡ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int MuteAllRemoteAudioStreams(bool muted);

            /**
            * ָԶû/ָԶûȡ/ֹԶûƵ
            * ע ÷ӰƵĽգֻǲƵ
            *
            * @param uid   ָû
            * @param muted True˷羲 Falseȡ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int MuteRemoteAudioStream(const char* uid, bool muted);

#pragma endregion 

#pragma region ˫

            /**
            * ʹ˫/ģʽ
            *
            * @param enabled ָ˫ߵģʽ true˫ falseĬϣ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int EnableDualStreamMode(bool enabled);

            /**
            * СĲڿ˫ģʽʱЧ
            * СֱҪʹĳɱ 360*640С 180*320СҪ̫
            * ע ȷjoinChannel֮ǰá
            *
            * @param width   ƵĿ
            * @param height  ƵĿ
            * @param fps     ֡
            * @param bitrate  (λkbps)
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetLowStreamVideoProfile(int width, int height, int fps, int bitrate);

            /**
            * ƵСл, ÷ָԶûƵСʹø÷ԸƵڵĴС̬Ӧ
            * ƵĴСԽԼͼԴ״̬ĵSDK ĬյƵСʡ
            * ʹƵñл
            *
            * @param uid         û ID
            * @param streamLevel ƵСQHVCInteractConstant.VIDEO_STREAM_LEVEL_HIGH (0): Ƶ
            *                                    QHVCInteractConstant.VIDEO_STREAM_LEVEL_LOW (1): ƵС
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetRemoteVideoStream(const char* uid, VIDEO_STREAM_LEVEL streamLevel);

#pragma endregion ˫

#pragma region 

            /**
            * N+1·תƣ1·+N·ϢԤӿ
            * ȷҪjoinChannel֮ǰá
            *
            * @param mixStreamConfig 
            * @param streamLifeCycle ڣ԰󶨷
            * @return 0 ɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetMixStreamInfo(const MixStreamConfig* mixStreamConfig, STREAM_LIFE_CYCLE streamLifeCycle);

            /**
            * תN+1·ʱºƵ
            * ע1. ȷIQHVCInteractCallBack.onFirstRemoteVideoFrame()ӿУ֮󣩣ø÷
            *     2count 10
            *
            * @param mixStreamInfos ϢȷеƵƵ
            * @param count mixStreamInfosĴС
            * @return 0:  óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetVideoCompositingLayout(const MixStreamRegion* mixStreamInfos, int count);

            /**
            * ȡ
            *
            * @return 0:  óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int ClearVideoCompositingLayout();

#pragma endregion 

#pragma region 豸

            /**
            * ͷ豸б
            *
            * @param [in] 豸б
            */
            QHVC_API void FreeDeviceList(__in DeviceInfo* parrDeviceList);

            /**
            * ȡƵ豸б
            *
            * @param [out] Ƶ豸
            * @return Ƶ豸б
            */
            QHVC_API DeviceInfo* GetVideoDeviceList(__out int& deviceCount);

            /**
            * ȡǰƵ豸
            *
            * @param deviceId 豸ID
            * @param length deviceId
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int GetVideoDevice(__out char* deviceId, int length);

            /**
            * õǰƵ豸
            *
            * @param deviceId 豸ID
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int SetVideoDevice(__in const char* deviceId);

            /**
            * ȡƵ豸б
            *
            * @param deviceType [in] Ƶ豸ͣ豸
            * @param deviceCount [out] Ƶ豸
            * @return Ƶ豸б
            */
            QHVC_API DeviceInfo* GetAudioDeviceList(__in AUDIO_DEVICE_TYPE deviceType, __out int& deviceCount);

            /**
            * ȡǰƵ豸
            *
            * @param deviceType [in] Ƶ豸ͣ豸
            * @param deviceId 豸ID
            * @param length deviceId
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int GetAudioDevice(__in AUDIO_DEVICE_TYPE deviceType, __out char* deviceId, int length);

            /**
            * õǰƵ豸
            *
            * @param deviceType [in] Ƶ豸ͣ豸
            * @param deviceId 豸ID
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int SetAudioDevice(__in AUDIO_DEVICE_TYPE deviceType, __in const char* deviceId);

            /**
            * ȡǰƵ豸
            *
            * @param deviceType [in] Ƶ豸ͣ豸
            * @param volume [out] 0~255
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int GetAudioDeviceVolume(__in AUDIO_DEVICE_TYPE deviceType, __out int& volume);

            /**
            * õǰƵ豸
            *
            * @param deviceType [in] Ƶ豸ͣ豸
            * @param volume [in] 0~255
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int SetAudioDeviceVolume(__in AUDIO_DEVICE_TYPE deviceType, __in int volume);

            /**
            * ȡǰ豸Ƿ
            *
            * @param deviceType [in] Ƶ豸ͣ豸
            * @param mute [out] true false Ǿ
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int GetAudioDeviceMute(__in AUDIO_DEVICE_TYPE deviceType, __out bool& mute);

            /**
            * õǰ豸Ƿ
            *
            * @param deviceType [in] Ƶ豸ͣ豸
            * @param mute [in] true false Ǿ
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int SetAudioDeviceMute(__in AUDIO_DEVICE_TYPE deviceType, __in bool mute);
#pragma endregion 豸
        }
    }
}

#endif